
;****************************************************************************************
;*                           DCF77-FUNKUHR MIT ANZEIGE VON DL3UKH ALS MUTTERUHR         *
;*                           ==================================================         *
;*                                                                                      *
;****************************************************************************************

    LIST    P=16F628A    
    TITLE   "DCF-77 FUNKUHR"

    INCLUDE <P16F628A.INC>

    ERRORLEVEL -302

;ALS PIC-IC WURDE GENOMMEN PIC16F628A

;DER QUARZ HAT 16,0000 MHZ ALSO T=0.0625S  T==TAKTZEIT 

;PROGRAMMIEREINSTELLUNGEN:
;CP   KEIN HAKEN     CPD    KEIN HAKEN 
;LVP  KEIN HAKEN     BOREN  KEIN HAKEN
;MCLR ALS I/O        PWRTEN DISABLE
;WDTE KEIN HAKEN     OSC    ALS HS    

;PROGRAMMIERMODUS:
;INTERNAL 5V   INTERNAL 5V
;TRISTATE      HVP      

__CONFIG   _HS_OSC & _WDT_OFF & _PWRTE_OFF & _BODEN_ON & _MCLRE_OFF & _LVP_OFF & _DATA_CP_OFF & _CP_OFF


;MAN KANN HIER DIE PIEPS-UHRZEIT NDERN
;ZEIT FR PIEPS ZUR VOLLEN STUNDE IN DER 00SEC  1SEC LANG
;STELL_AB_HIER   EQU 0X07    ;ALSO JETZT AB 7UHR    // KLEINSTE UHRZEIT IST 0X00 / ALSO NULL UHR
;STELL_BIS_HIER  EQU 0X22    ;ALSO JETZT BIS 22UHR  // GRSSTE UHRZEIT IST 0X23  / ALSO 23UHR
;ALSO
;MIT 0X00 BIS 0X23 PIEPST ES JEDE STUNDE AUCH IN DER NACHT !!!!!!!! 

;REGISTER (MAX. 80 STCK) ZUORDNEN NACHFOLGEND DER FESTEN REGISTERN
 
W_STACK EQU 0X22       ;FR PUSH+POP
S_STACK EQU 0X23       ;FR PUSH+POP
HELP0   EQU 0X24       ;500MS-ZHLER //BEI 15SEC-PAUSE UND 1SEC-QUARZ-TAKT
MERK    EQU 0X25       ;BIT6=BEI MIN/H NICHTBEREINSTIMMUNG DOCH ZULASSUNG
                    ;     BEI 1.-TEM START
                    ;BIT7=MERKER BEI DCF-ZEITBERNAHME KURZ BLINKEN
                    ;     VON 00SEC NACH 01SEC
                    ;BIT0=ZEITUMSTELLUNGBIT DER 16-SEC
                    ;BIT1=MERKER FR ZEITUMSTELLUNG

Z_LL    EQU 0X26       ;ZHLER-LOW-(LOW=BYTE)
Z_LH    EQU 0X27       ;ZHLER-LOW-(HIGH=BYTE)
Z_H     EQU 0X28       ;ZHLER-HIGH-(ZEIT)
Z_IMP   EQU 0X29       ;ZHLER SEC-IMPULSE
DCF_DA  EQU 0X2A       ;BIT0 ==> 1=DCF IST DA, 0=DCF IST NICHT DA

OK      EQU 0X2B       ;BIT0=MIN-PARITT BIT1=H-PARITT BIT2=RAHMEN><
PAR     EQU 0X2C       ;PARITT IM AUSLESEPROZESS
ZUST    EQU 0X2D       ;ZUSTAND =1


SEC     EQU 0X2E       ;ANZEIGE-ZEIT UND QARZ-ZEIT
MIN     EQU 0X2F
H       EQU 0X30

I_MIN   EQU 0X31       ;IMPULS AUSGELESENE ZEIT
I_H     EQU 0X32

MIN_V   EQU 0X33       ;ZUR +1 VERGLEICHSBERECHNUNG
H_V     EQU 0X34

MIN_1   EQU 0X35       ;ANFANGSVERGLEICH ODER BEI ZEITUMSTELLUNG
H_1     EQU 0X36       ;ZWEI ZEITEN MESSEN ZUR SICHERHEIT



SZ      EQU 0X37       ;SOMMERZEIT MIT HIGH WINTERZEIT LOW BIT18 SZ-BIT0 GENUTZT
WOC     EQU 0X38       ;WOCHENTAG AUSWERTER 1=MON 7=SON BIT42-44
KALT    EQU 0X39       ;KALENDERTAG WIE 31.
MONA    EQU 0X3A       ;MONAT
JAR     EQU 0X3B       ;JAHR

;==================================================
HELP1   EQU 0X3C       ;HILFSZELLE
HELP2   EQU 0X3D       ;HILFSZELLE
X4      EQU 0X3E       ;MS1 * 4 WEGEN QUARZ
;==================================================
;4-BIT DATENBUS
MERKE   EQU 0X3F
BIT     EQU 0X40

;==================================================
;GERADE UND UNGERADE SEC-IMPULS
TXT     EQU 0X41    ;TABELLE DIE MIN
ZAE     EQU 0X42    ;ZAEHLER FUER SUCHEN IN TABELLE
DECOD   EQU 0X43    ;BIT0 = HIGH ES WURDE SCHON MAL ZUM ERSTEN MAL GESTELLT

;==================================================
;FUER DAS STELLEN MITTELS TASTER
STELL   EQU 0X44    ;MERKER HILFSZELLE

;==================================================


;VARIABLEN
BIT7    EQU 7       ; BIT 7
BIT6    EQU 6       ; BIT 6
BIT5    EQU 5       ; BIT 5
BIT4    EQU 4       ; BIT 4
BIT3    EQU 3       ; BIT 3 
BIT2    EQU 2       ; BIT 2
BIT1    EQU 1       ; BIT 1 
BIT0    EQU 0       ; BIT 0


;==================================================
RS      EQU 2       ; PORTA BIT2 UMSCHALTEN BEFEHL/DATEN      BEI WRITE DATEN IST ES HIGH
EN      EQU 3       ; PORTA BIT3 ENABLE FALLENDE FLANKE

UN      EQU 1       ;PORTA BIT1 UNGERADE MIN 1SEC-IMPULS
GR      EQU 0       ;PORTA BIT0 GERADE MIN 1SEC-IMPULS

ST      EQU 0       ;PORTB BIT0 TASTER ZUM STELLEN
;==================================================

;------------ MACROS ---------------------------------------------------------

PUSH    MACRO
        MOVWF   W_STACK
        MOVF    STATUS, W
        MOVWF   S_STACK
        ENDM
;----------------------------------------------------------------------------

POP     MACRO
        MOVF    S_STACK, W
        MOVWF   STATUS
        SWAPF   W_STACK, F
        SWAPF   W_STACK, W
        ENDM
;----------------------------------------------------------------------------

MS1     MACRO               ; FR EINE MILLISEKUNDE
        BCF INTCON, T0IF    ;TIMER0 KEIN INTERRUPT + OVERFLOW = 0
        BCF INTCON, T0IE    ;KEIN INTERRUPT
        MOVLW   0X06        ;1MS/16=6.25MYS/0.25MYS=250TAKTE
        MOVWF   TMR0        ;0X100(256)-0XFA(250)=0X06(6)  +OHNE(JUSTAGE)
        BSF STATUS, RP0     ;BANK1
        MOVLW   B'00000001' ;PRESCALE1:4 / SYSTEMCLOCK T/4 ==>1/16
        MOVWF   OPTION_REG  ;TEILER 1:4 + CYCLUS CLOCK
        BCF STATUS, RP0     ;BANK0
        ENDM
;----------------------------------------------------------------------------



;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;ZEITEN GENDERT
; ACHTUNG HIER KOMMEN DIE IMPULS-BEREICHE REIN
; IN DIESEN BEREICHEN WERDEN DIE LNGEN ZU LOW UND HIGH

AUSW    MACRO
        MOVLW   D'60'       ;ALT 60
        SUBWF   Z_H, W
        BTFSS   STATUS, C   ;GRER ALS 60MS SONST FEHLERPUNKT
        GOTO    VOR1
        MOVLW   D'140'      ;AUCH SCHREIBBAR ALS H'8C'
        SUBWF   Z_H, W
        BTFSC   STATUS, C   ;KLEINER ALS 140MS SONST FEHLERPUNKT
        GOTO    SU
        MOVLW   D'0'
        MOVWF   Z_H
        GOTO    RECHN

SU      MOVLW   D'240'      ;
        SUBWF   Z_H, W
        BTFSC   STATUS, C   ;KLEINER ALS 240MS SONST FEHLERPUNKT
        GOTO    VOR1
        MOVLW   D'160'      ;ALT 160      
        SUBWF   Z_H, W
        BTFSS   STATUS, C   ;GRER ALS 160MS SONST FEHLERPUNKT
        GOTO    VOR1
        MOVLW   D'1'
        MOVWF   Z_H
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

RECHN   MOVLW   D'59'       ;BEI >= 59 ANS ENDE
        SUBWF   Z_IMP, W
        BTFSC   STATUS, C
        GOTO    D_ENDE

        MOVLW   D'16'       ;BEI <= 16 ANS ENDE
        SUBWF   Z_IMP, W
        BTFSS   STATUS, C
        GOTO    D_ENDE


;------------ JETZT GEHTS LOS ---------------------------------------

        MOVLW   D'16'       ;ZEITUMSTELLUNG
        SUBWF   Z_IMP, W
        BTFSS   STATUS, Z
        GOTO    MI00
        MOVLW   D'1'
        SUBWF   Z_H, W
        BTFSS   STATUS, Z
        GOTO    MI01
        BSF     MERK, BIT0
        GOTO    D_ENDE

MI01    BCF     MERK, BIT0
        GOTO    D_ENDE

MI00    MOVLW   D'17'       ;WINTER/SOMMER-ZEIT
        SUBWF   Z_IMP, W
        BTFSS   STATUS, Z
        GOTO    MI03
        MOVLW   D'1'
        SUBWF   Z_H, W
        BTFSS   STATUS, Z
        GOTO    MI02
        BSF     SZ, BIT0
        GOTO    D_ENDE  

MI02    BCF     SZ, BIT0
        GOTO    D_ENDE

MI03    MOVLW   D'42'       ;WOCHENTAG
        SUBWF   Z_IMP, W
        BTFSS   STATUS, Z
        GOTO    MI04
        MOVLW   D'1'
        SUBWF   Z_H, W
        BTFSS   STATUS, Z
        GOTO    MI05
        BSF     WOC, BIT0
        GOTO    D_ENDE  

MI05    BCF     WOC, BIT0
        GOTO    D_ENDE

MI04    MOVLW   D'43'       ;WOCHENTAG
        SUBWF   Z_IMP, W
        BTFSS   STATUS, Z
        GOTO    MI06
        MOVLW   D'1'
        SUBWF   Z_H, W
        BTFSS   STATUS, Z
        GOTO    MI07
        BSF     WOC, BIT1
        GOTO    D_ENDE  

MI07    BCF     WOC, BIT1
        GOTO    D_ENDE

MI06    MOVLW   D'44'       ;WOCHENTAG
        SUBWF   Z_IMP, W
        BTFSS   STATUS, Z
        GOTO    AS01
        MOVLW   D'1'
        SUBWF   Z_H, W
        BTFSS   STATUS, Z
        GOTO    MI08
        BSF     WOC, BIT2
        GOTO    D_ENDE  

MI08    BCF     WOC, BIT2
        GOTO    D_ENDE


AS01    MOVLW   D'36'       ;KALENDERTAG
        SUBWF   Z_IMP, W
        BTFSS   STATUS, Z
        GOTO    AS03
        MOVLW   D'1'
        SUBWF   Z_H, W
        BTFSS   STATUS, Z
        GOTO    AS02
        BSF     KALT, BIT0
        GOTO    A_ENDE  

AS02    BCF     KALT, BIT0
        GOTO    A_ENDE

AS03    MOVLW   D'37'       ;KALENDERTAG
        SUBWF   Z_IMP, W
        BTFSS   STATUS, Z
        GOTO    AS05
        MOVLW   D'1'
        SUBWF   Z_H, W
        BTFSS   STATUS, Z
        GOTO    AS04
        BSF     KALT, BIT1
        GOTO    D_ENDE  

AS04    BCF     KALT, BIT1
        GOTO    D_ENDE

AS05    MOVLW   D'38'       ;KALENDERTAG
        SUBWF   Z_IMP, W
        BTFSS   STATUS, Z
        GOTO    AS07
        MOVLW   D'1'
        SUBWF   Z_H, W
        BTFSS   STATUS, Z
        GOTO    AS06
        BSF     KALT, BIT2
        GOTO    D_ENDE  

AS06    BCF     KALT, BIT2
        GOTO    D_ENDE

AS07    MOVLW   D'39'       ;KALENDERTAG
        SUBWF   Z_IMP, W
        BTFSS   STATUS, Z
        GOTO    AS09
        MOVLW   D'1'
        SUBWF   Z_H, W
        BTFSS   STATUS, Z
        GOTO    AS08
        BSF     KALT, BIT3
        GOTO    D_ENDE  

AS08    BCF     KALT, BIT3
        GOTO    D_ENDE

AS09    MOVLW   D'40'       ;KALENDERTAG
        SUBWF   Z_IMP, W
        BTFSS   STATUS, Z
        GOTO    AS11
        MOVLW   D'1'
        SUBWF   Z_H, W
        BTFSS   STATUS, Z
        GOTO    AS10
        BSF     KALT, BIT4
        GOTO    D_ENDE  

AS10    BCF     KALT, BIT4
        GOTO    D_ENDE

AS11    MOVLW   D'41'       ;KALENDERTAG
        SUBWF   Z_IMP, W
        BTFSS   STATUS, Z
        GOTO    AZ00
        MOVLW   D'1'
        SUBWF   Z_H, W
        BTFSS   STATUS, Z
        GOTO    AS12
        BSF     KALT, BIT5
        GOTO    D_ENDE  

AS12    BCF     KALT, BIT5
        GOTO    D_ENDE


AZ00    MOVLW   D'45'       ;MONAT
        SUBWF   Z_IMP, W
        BTFSS   STATUS, Z
        GOTO    AZ02
        MOVLW   D'1'
        SUBWF   Z_H, W
        BTFSS   STATUS, Z
        GOTO    AZ01
        BSF     MONA, BIT0
        GOTO    D_ENDE  

AZ01    BCF     MONA, BIT0
        GOTO    D_ENDE


AZ02    MOVLW   D'46'       ;MONAT
        SUBWF   Z_IMP, W
        BTFSS   STATUS, Z
        GOTO    AZ04
        MOVLW   D'1'
        SUBWF   Z_H, W
        BTFSS   STATUS, Z
        GOTO    AZ03
        BSF     MONA, BIT1
        GOTO    D_ENDE  

AZ03    BCF     MONA, BIT1
        GOTO    D_ENDE


AZ04    MOVLW   D'47'       ;MONAT
        SUBWF   Z_IMP, W
        BTFSS   STATUS, Z
        GOTO    AZ06
        MOVLW   D'1'
        SUBWF   Z_H, W
        BTFSS   STATUS, Z
        GOTO    AZ05
        BSF     MONA, BIT2
        GOTO    D_ENDE  

AZ05    BCF     MONA, BIT2
        GOTO    D_ENDE


AZ06    MOVLW   D'48'       ;MONAT
        SUBWF   Z_IMP, W
        BTFSS   STATUS, Z
        GOTO    AZ08
        MOVLW   D'1'
        SUBWF   Z_H, W
        BTFSS   STATUS, Z
        GOTO    AZ07
        BSF     MONA, BIT3
        GOTO    D_ENDE  

AZ07    BCF     MONA, BIT3
        GOTO    D_ENDE


AZ08    MOVLW   D'49'       ;MONAT
        SUBWF   Z_IMP, W
        BTFSS   STATUS, Z
        GOTO    AZ10
        MOVLW   D'1'
        SUBWF   Z_H, W
        BTFSS   STATUS, Z
        GOTO    AZ09
        BSF     MONA, BIT4
        GOTO    D_ENDE  

AZ09    BCF     MONA, BIT4
        GOTO    D_ENDE



AZ10    MOVLW   D'50'       ;JAHR
        SUBWF   Z_IMP, W
        BTFSS   STATUS, Z
        GOTO    AZ12
        MOVLW   D'1'
        SUBWF   Z_H, W
        BTFSS   STATUS, Z
        GOTO    AZ11
        BSF     JAR, BIT0
        GOTO    D_ENDE  

AZ11    BCF     JAR, BIT0
        GOTO    D_ENDE


AZ12    MOVLW   D'51'       ;JAHR
        SUBWF   Z_IMP, W
        BTFSS   STATUS, Z
        GOTO    AZ14
        MOVLW   D'1'
        SUBWF   Z_H, W
        BTFSS   STATUS, Z
        GOTO    AZ13
        BSF     JAR, BIT1
        GOTO    D_ENDE  

AZ13    BCF     JAR, BIT1
        GOTO    D_ENDE


AZ14    MOVLW   D'52'       ;JAHR
        SUBWF   Z_IMP, W
        BTFSS   STATUS, Z
        GOTO    AZ16
        MOVLW   D'1'
        SUBWF   Z_H, W
        BTFSS   STATUS, Z
        GOTO    AZ15
        BSF     JAR, BIT2
        GOTO    D_ENDE  

AZ15    BCF     JAR, BIT2
        GOTO    D_ENDE


AZ16    MOVLW   D'53'       ;JAHR
        SUBWF   Z_IMP, W
        BTFSS   STATUS, Z
        GOTO    AZ18
        MOVLW   D'1'
        SUBWF   Z_H, W
        BTFSS   STATUS, Z
        GOTO    AZ17
        BSF     JAR, BIT3
        GOTO    D_ENDE  

AZ17    BCF     JAR, BIT3
        GOTO    D_ENDE


AZ18    MOVLW   D'54'       ;JAHR
        SUBWF   Z_IMP, W
        BTFSS   STATUS, Z
        GOTO    AZ20
        MOVLW   D'1'
        SUBWF   Z_H, W
        BTFSS   STATUS, Z
        GOTO    AZ19
        BSF     JAR, BIT4
        GOTO    D_ENDE  

AZ19    BCF     JAR, BIT4
        GOTO    D_ENDE


AZ20    MOVLW   D'55'       ;JAHR
        SUBWF   Z_IMP, W
        BTFSS   STATUS, Z
        GOTO    AZ22
        MOVLW   D'1'
        SUBWF   Z_H, W
        BTFSS   STATUS, Z
        GOTO    AZ21
        BSF     JAR, BIT5
        GOTO    D_ENDE  

AZ21    BCF     JAR, BIT5
        GOTO    D_ENDE


AZ22    MOVLW   D'56'       ;JAHR
        SUBWF   Z_IMP, W
        BTFSS   STATUS, Z
        GOTO    AZ24
        MOVLW   D'1'
        SUBWF   Z_H, W
        BTFSS   STATUS, Z
        GOTO    AZ23
        BSF     JAR, BIT6
        GOTO    D_ENDE  

AZ23    BCF     JAR, BIT6
        GOTO    D_ENDE


AZ24    MOVLW   D'57'       ;JAHR
        SUBWF   Z_IMP, W
        BTFSS   STATUS, Z
        GOTO    MI000
        MOVLW   D'1'
        SUBWF   Z_H, W
        BTFSS   STATUS, Z
        GOTO    AZ25
        BSF     JAR, BIT7
        GOTO    D_ENDE  

AZ25    BCF     JAR, BIT7
        GOTO    D_ENDE





MI000   MOVLW   D'21'       ;1MIN
        SUBWF   Z_IMP, W
        BTFSS   STATUS, Z
        GOTO    I11
        MOVLW   D'1'
        SUBWF   Z_H, W
        BTFSS   STATUS, Z
        GOTO    D_ENDE
        BSF     I_MIN, BIT0
        BTFSS   PAR, BIT0   ;PARITT
        GOTO    PA0
        BCF     PAR, BIT0
        GOTO    D_ENDE

PA0     BSF     PAR, BIT0
        GOTO    D_ENDE

I11     MOVLW   D'22'       ;2MIN
        SUBWF   Z_IMP, W
        BTFSS   STATUS, Z
        GOTO    I12
        MOVLW   D'1'
        SUBWF   Z_H, W
        BTFSS   STATUS, Z
        GOTO    D_ENDE
        BSF     I_MIN, BIT1
        BTFSS   PAR, BIT0   ;PARITT
        GOTO    PA1
        BCF     PAR, BIT0
        GOTO    D_ENDE

PA1     BSF     PAR, BIT0
        GOTO    D_ENDE


I12     MOVLW   D'23'       ;4MIN
        SUBWF   Z_IMP, W
        BTFSS   STATUS, Z
        GOTO    I13
        MOVLW   D'1'
        SUBWF   Z_H, W
        BTFSS   STATUS, Z
        GOTO    D_ENDE
        BSF     I_MIN, BIT2
        BTFSS   PAR, BIT0   ;PARITT
        GOTO    PA2
        BCF     PAR, BIT0
        GOTO    D_ENDE

PA2     BSF     PAR, BIT0
        GOTO    D_ENDE

I13     MOVLW   D'24'       ;8MIN
        SUBWF   Z_IMP, W
        BTFSS   STATUS, Z
        GOTO    I14
        MOVLW   D'1'
        SUBWF   Z_H, W
        BTFSS   STATUS, Z
        GOTO    D_ENDE
        BSF     I_MIN, BIT3
        BTFSS   PAR, BIT0   ;PARITT
        GOTO    PA3
        BCF     PAR, BIT0
        GOTO    D_ENDE

PA3     BSF PAR, BIT0
        GOTO    D_ENDE


I14     MOVLW   D'25'       ;10MIN
        SUBWF   Z_IMP, W
        BTFSS   STATUS, Z
        GOTO    I15
        MOVLW   D'1'
        SUBWF   Z_H, W
        BTFSS   STATUS, Z
        GOTO    D_ENDE
        BSF     I_MIN, BIT4
        BTFSS   PAR, BIT0   ;PARITT
        GOTO    PA4
        BCF     PAR, BIT0
        GOTO    D_ENDE

PA4     BSF     PAR, BIT0
        GOTO    D_ENDE


I15     MOVLW   D'26'       ;20MIN
        SUBWF   Z_IMP, W
        BTFSS   STATUS, Z
        GOTO    I16
        MOVLW   D'1'
        SUBWF   Z_H, W
        BTFSS   STATUS, Z
        GOTO    D_ENDE
        BSF     I_MIN, BIT5
        BTFSS   PAR, BIT0   ;PARITT
        GOTO    PA5
        BCF     PAR, BIT0
        GOTO    D_ENDE

PA5     BSF     PAR, BIT0
        GOTO    D_ENDE


I16     MOVLW   D'27'       ;40MIN
        SUBWF   Z_IMP, W
        BTFSS   STATUS, Z
        GOTO    I17
        MOVLW   D'1'
        SUBWF   Z_H, W
        BTFSS   STATUS, Z
        GOTO    D_ENDE
        BSF     I_MIN, BIT6
        BTFSS   PAR, BIT0   ;PARITT
        GOTO    PA6
        BCF     PAR, BIT0
        GOTO    D_ENDE

PA6     BSF     PAR, BIT0
        GOTO    D_ENDE


I17     MOVLW   D'28'       ;PARITT
        SUBWF   Z_IMP, W
        BTFSS   STATUS, Z
        GOTO    II1
        MOVLW   D'1'
        SUBWF   Z_H, W
        BTFSS   STATUS, Z   ;
        GOTO    IP1
        BTFSS   PAR, BIT0   ;
        GOTO    IP2
        BSF     OK, BIT0
        GOTO    D_ENDE

IP2     BCF     OK, BIT0
        GOTO    VOR

IP1     BTFSC   PAR, BIT0
        GOTO    IP3
        BSF     OK, BIT0
        GOTO    D_ENDE

IP3     BCF OK, BIT0
        GOTO    VOR

II1     MOVLW   D'29'       ;1H
        SUBWF   Z_IMP, W
        BTFSS   STATUS, Z
        GOTO    II2
        MOVLW   D'1'
        SUBWF   Z_H, W
        BTFSS   STATUS, Z
        GOTO    D_ENDE
        BSF     I_H, BIT0
        BTFSS   PAR, BIT1   ;PARITT
        GOTO    PA7
        BCF     PAR, BIT1
        GOTO    D_ENDE

PA7     BSF     PAR, BIT1
        GOTO    D_ENDE

II2     MOVLW   D'30'       ;2H
        SUBWF   Z_IMP, W
        BTFSS   STATUS, Z
        GOTO    II3
        MOVLW   D'1'
        SUBWF   Z_H, W
        BTFSS   STATUS, Z
        GOTO    D_ENDE
        BSF     I_H, BIT1
        BTFSS   PAR, BIT1   ;PARITT
        GOTO    PA9
        BCF     PAR, BIT1
        GOTO    D_ENDE

PA9     BSF     PAR, BIT1
        GOTO    D_ENDE

II3     MOVLW   D'31'       ;4H
        SUBWF   Z_IMP, W
        BTFSS   STATUS, Z
        GOTO    II4
        MOVLW   D'1'
        SUBWF   Z_H, W
        BTFSS   STATUS, Z
        GOTO    D_ENDE
        BSF     I_H, BIT2
        BTFSS   PAR, BIT1   ;PARITT
        GOTO    PA10
        BCF     PAR, BIT1
        GOTO    D_ENDE

PA10    BSF     PAR, BIT1
        GOTO    D_ENDE


II4     MOVLW   D'32'       ;8H
        SUBWF   Z_IMP, W
        BTFSS   STATUS, Z
        GOTO    II5
        MOVLW   D'1'
        SUBWF   Z_H, W
        BTFSS   STATUS, Z
        GOTO    D_ENDE
        BSF     I_H, BIT3
        BTFSS   PAR, BIT1   ;PARITT
        GOTO    PA11
        BCF     PAR, BIT1
        GOTO    D_ENDE

PA11    BSF     PAR, BIT1
        GOTO    D_ENDE

II5     MOVLW   D'33'       ;10H
        SUBWF   Z_IMP, W
        BTFSS   STATUS, Z
        GOTO    II6
        MOVLW   D'1'
        SUBWF   Z_H, W
        BTFSS   STATUS, Z
        GOTO    D_ENDE
        BSF     I_H, BIT4
        BTFSS   PAR, BIT1   ;PARITT
        GOTO    PA12
        BCF     PAR, BIT1
        GOTO    D_ENDE

PA12    BSF     PAR, BIT1
        GOTO    D_ENDE

II6     MOVLW   D'34'       ;20H
        SUBWF   Z_IMP, W
        BTFSS   STATUS, Z
        GOTO    II7
        MOVLW   D'1'
        SUBWF   Z_H, W
        BTFSS   STATUS, Z
        GOTO    D_ENDE
        BSF     I_H, BIT5
        BTFSS   PAR, BIT1   ;PARITT
        GOTO    PA13
        BCF     PAR, BIT1
        GOTO    D_ENDE

PA13    BSF     PAR, BIT1
        GOTO    D_ENDE


II7     MOVLW   D'35'       ;PARITT
        SUBWF   Z_IMP, W
        BTFSS   STATUS, Z
        GOTO    A_ENDE
        MOVLW   D'1'
        SUBWF   Z_H, W
        BTFSS   STATUS, Z
        GOTO    XIP1
        BTFSS   PAR, BIT1
        GOTO    XIP2
        BSF     OK, BIT1
        GOTO    D_ENDE

XIP2    BCF     OK, BIT1
        GOTO    VOR

XIP1    BTFSC   PAR, BIT1
        GOTO    XIP3
        BSF     OK, BIT1
        GOTO    D_ENDE

XIP3    BCF     OK, BIT1
        GOTO    VOR

A_ENDE  MOVLW   D'36'       ;AUSWERTEN
        SUBWF   Z_IMP, W
        BTFSS   STATUS, Z
        GOTO    D_ENDE

;AUSWERTEN
        MOVLW   0X07        ;KNNTE MAN WEGLASSEN
        SUBWF   OK, W
        BTFSS   STATUS, Z
        GOTO    VOR

;-------------- ANZEIGE JA ODER NEIN ------------------------------------------

        INCF    ZUST, F
    
        MOVLW   D'1'
        SUBWF   ZUST, W
        BTFSS   STATUS, Z
        GOTO    GO1

;-------------- MERKER FR ZEITUMSTELLUNG BEI UNGELEICHHEIT -------------------
    
        MOVLW   0X45
        SUBWF   MIN, W
        BTFSC   STATUS, C   ;KLEINER GLEICH DER 45-TEN MIN SPRUNG
        GOTO    STA1        ;HIER GRER DER 45-TEN MIN
    
        MOVLW   0X30
        SUBWF   MIN, W
        BTFSS   STATUS, C   ;GRER 30MIN SPRUNG
        GOTO    STA
    
        BTFSS   MERK, BIT0  ;ALSO JETZT ZWISCHEN DER 30. BIS 45.-TEN MIN
        GOTO    STA3
        BSF     MERK, BIT1
        GOTO    STA

STA3    BCF     MERK, BIT1
        GOTO    STA

STA1    BTFSS   MERK, BIT1
        GOTO    STA2
        BTFSS   MERK, BIT0
        GOTO    STA2
        GOTO    STA

STA2    BCF MERK, BIT1

                       ;VON 30-45MIN WIRD BIT1 HIGH GESETZT
                       ;UND VON 45-59MIN MU BIT1 + BIT0 HIGH SEIN
                       ;-AB 00-30MIN BLEIBT BIT1 GESETZT BIS UNGLEICHHEIT AUFTRITT
                       ; UND WIRD DANN SOFORT ANGEZEIGT

;-------------- MIN+H VERGLEICH ----------------------------------------------

STA     MOVF    MIN, W
        MOVWF   MIN_V
        MOVF    H, W
        MOVWF   H_V

LLOP1   BCF     INTCON, GIE     ;INTERRUPT SPERREN, DA BANK1 VORKOMMT
        BTFSC   INTCON, GIE
        GOTO    LLOP1
        CALL    PLUS1
        BSF     INTCON, GIE     ;INTERRUPT WIEDER ZULASSEN
    
        MOVF    I_MIN, W
        SUBWF   MIN_V, W
        BTFSS   STATUS, Z
        GOTO    GO_F_1
        MOVF    I_H, W
        SUBWF   H_V, W
        BTFSS   STATUS, Z
        GOTO    GO_F_1
    
        MOVLW   D'100'          ;ALLES OK KANN MAN IN DER MIN-LUECKE ANZEIGEN
        MOVWF   ZUST
        GOTO    D_ENDE

GO1     MOVLW   D'2'
        SUBWF   ZUST, W
        BTFSS   STATUS, Z
        GOTO    GO3
    
        MOVF    MIN_1, W
        MOVWF   MIN_V
        MOVF    H_1, W
        MOVWF   H_V

LLOP2   BCF     INTCON, GIE     ;INTERRUPT SPERREN, DA BANK1 VORKOMMT
        BTFSC   INTCON, GIE
        GOTO    LLOP2
        CALL    PLUS1
        BSF     INTCON, GIE     ;INTERRUPT WIEDER ZULASSEN
    
        MOVF    I_MIN, W
        SUBWF   MIN_V, W
        BTFSS   STATUS, Z
        GOTO    GO_F_2
        MOVF    I_H, W
        SUBWF   H_V, W
        BTFSS   STATUS, Z
        GOTO    GO_F_2

ZUR     MOVLW   D'100'          ;ALLES OK KANN MAN IN DER MIN-LUECKE ANZEIGEN
        MOVWF   ZUST
        GOTO    D_ENDE

GO_F_1  BTFSS   MERK, BIT1      ;MERKER FR UNGLEICHHEIT ==> ZEITUMSTELLUNG
        GOTO    GOF1
        BCF     MERK, BIT0
        BCF     MERK, BIT1
        GOTO    ZUR

GOF1    MOVF    I_MIN, W
        MOVWF   MIN_1
        MOVF    I_H, W
        MOVWF   H_1
        GOTO    D_ENDE

GO_F_2  MOVF    I_MIN, W
        MOVWF   MIN_1
        MOVF    I_H, W
        MOVWF   H_1
    
        MOVLW   D'1'
        MOVWF   ZUST
        GOTO    D_ENDE

GO3     MOVLW   D'0'
        MOVWF   ZUST
        GOTO    D_ENDE

;-----------------------------------------------------------------------------

VOR1    BCF OK, BIT2    ;FEHLER MERKEN RAHMEN < >
VOR ;BSF PORTB, FEHLER   ;PARITT STIMMT NICHT PUNKT WIRD SOFORT
                ;ANGEZEIGT UND GEMERKT

        MOVLW   H'85'                  
        CALL    BEFEHL
        MOVLW   H'2C'
        CALL    DATEN


D_ENDE  NOP
        ENDM

;------------------------- ENDE MACROS -----------------------------------------------


    ORG 0X0000
    GOTO MAIN           ; SPRUNG ZUM HAUPTPROGRAMM
    ORG 0X0004
    GOTO INTERR         ; SPRUNG ZUM INTERRUPTPROGRAMM

    ORG 0X0010
;*****************************************************************************
;*                              INTERRUPTPROGRAMM                            *
;*                              22.09.02                                     *
;*****************************************************************************

INTERR  PUSH
        BCF T1CON, TMR1ON               ;STOP TIMER1        ;4T + 8TINTERRUPT? JUSTAGE
        BCF PIR1, TMR1IF                ;OVERFLOW 0 MACHEN  ;4T
        BSF INTCON, PEIE                ;ZUR SICHERHEIT PERIPH. INTERRUPT ZULASSEN
        MOVLW   0XD0                    ;4T
        MOVWF   TMR1L                   ;4T
        MOVLW   0X0B                    ;4T
        MOVWF   TMR1H                   ;4T

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;JUSTAGE GENDERT
        
        NOP                             ;4T ZUR JUSTAGE
        NOP                             ;4T
        NOP                             ;4T
        NOP                             ;4T
    
        NOP                             ;4T
        NOP                             ;4T
    
        
        NOP
        NOP
        NOP
        NOP
        NOP

QKJ     MOVLW   0X31        ;+STEUERBITS FR DIESEN TIMER   ;4T
        MOVWF   T1CON       ;START TIMER1       ;4T GESAMT=14*4T + 1*8T=64T

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

        DECF    HELP0, F    ;SEKUNDEN-ERKENNUNG // SPRUNG BEI DEM ENTSPRECHEND ???? KOENNTE FEHLER SEIN

        MOVF    HELP0, W
        SUBLW   D'1'
        BTFSC   STATUS, Z
        GOTO    ZAEL

        MOVF    HELP0, W
        SUBLW   D'2'
        BTFSC   STATUS, Z
        GOTO    QEN

        MOVF    HELP0, W
        SUBLW   D'3'
        BTFSC   STATUS, Z
        GOTO    QEN

        MOVF    HELP0, W
        SUBLW   D'4'
        BTFSS   STATUS, Z
        GOTO    QEN123
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;TASTER ZUM STELLEN GEDRCKT CA. 1SEC DRCKEN

        BTFSS   PORTB, ST
        BSF     STELL, BIT7 ;MERKER FR STELLEN GESETZT / BEI MAIN ANFANGS-RESET MIT "CLRF STELL" CA. 1380ZEILE

;;;;;;;;;;;;;;;;;;;;;;;;;;;;


QEN123  MOVF    HELP0, W
        SUBLW   D'5'
        BTFSC   STATUS, Z
        GOTO    NO_SEC

        MOVF    HELP0, W
        SUBLW   D'6'
        BTFSC   STATUS, Z
        GOTO    QEN

        MOVF    HELP0, W
        SUBLW   D'7'
        BTFSC   STATUS, Z
        GOTO    QEN

        MOVF    HELP0, W         
        SUBLW   D'8'
        BTFSS   STATUS, Z
        GOTO    QEN

; BEI 1 ZEIT ZHLEN, SIEHE GLEICH UNTERHALB
  
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;NACHFRAGEN OB SCHON DCF GESTELLT / ALSO UHRZEIT DAS 1-TE MAL DECODIERT
IMP     BTFSS   DECOD, BIT0
        GOTO    QEN

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;HIER DER IMPULS FR DAS STELLEN MITTELS TASTER

        BTFSS   STELL, BIT7 ;MERKER FR STELLEN
        GOTO    IMP01

        BTFSS   STELL, BIT2 ;MERKER FR PAUSE2 
        GOTO    PAU01
        ;BCF     PORTA, UN
        ;BCF     PORTA, GR
        ;BCF     STELL, BIT1 ;SCHLUSS VON DER PAUSE1 BEIM STELLEN
        BCF     STELL, BIT2 ;MERKER FR PAUSE2 FOLGT
        BCF     STELL, BIT7 ;SCHLUSS VOM STELLEN UND MIT 2SEC PAUSE AM SCHLUSS
        GOTO    QEN

PAU01   BTFSS   STELL, BIT1 ;MERKER FR PAUSE1 
        GOTO    STE
        BCF     PORTA, UN
        BCF     PORTA, GR
        BCF     STELL, BIT1 ;SCHLUSS VON DER PAUSE1 BEIM STELLEN
        BSF     STELL, BIT2 ;MERKER FR PAUSE2 FOLGT
        GOTO    QEN

STE     BTFSS   STELL, BIT0 ;MERKER UNGERADE / GERADE SCHALTEN NACH EINANDER
        GOTO    GERR

        BSF     PORTA, UN   ;SCHALTEN MIT 1SEC ALS UNGERADE ZEIT
        BCF     STELL, BIT0 ;MERKER FR UNGERADE UND GERADE SCHALTEN
        BSF     STELL, BIT1 ;MERKER FR PAUSE1 FOLGT
        GOTO    QEN

;;;
GERR    BSF     PORTA, GR
        BSF     STELL, BIT0 ;MERKER FR GERADE UND UNGERADE SCHALTEN
        BSF     STELL, BIT1 ;MERKER FR PAUSE1 FOLGT
        GOTO    QEN

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;BEI 00SEC BEI GERADE ODER UNGERADE MIN 1SEC IMPULS
IMP01   MOVLW   H'00'        ;00SEC ABFRAGE OB JA
        SUBWF   SEC, W
        BTFSC   STATUS, Z
        GOTO    WETA

        BCF     PORTA, UN  ;LOESCHEN BEI NICHT 00SEC ALSO LOW
        BCF     PORTA, GR
        GOTO    QEN

;ZAE ZHLER MIT BEGINN NULL LADEN
WETA                CLRF   ZAE

GER                 CALL    GERADE
                    MOVWF   TXT
                    MOVLW   H'00'           ;ADRESSE SPEICHERN NEUES PCLATH AM ANFANG /// *.LST FILE ADRESSE KONTROLLIEREN !!!!
                    MOVWF   PCLATH

                    MOVLW   0XFF            ;TXT-ENDE-ERKENNUNG
                    SUBWF   TXT, W
                    BTFSS   STATUS, Z
                    GOTO    WEITX

                    BSF     PORTA, UN       ;BEI UNGERADE AUF HIGH
                    GOTO    QEN

WEITX               MOVF    TXT, W
                    SUBWF   MIN, W
                    BTFSC   STATUS, Z
                    GOTO    EINN
                    INCF    ZAE, F
                    GOTO    GER            ;NCHSTES BYTE AUS TABELLE LESEN/ENTNEHMEN

EINN                BSF     PORTA, GR      ;BEI GERADE  AUF HIGH
                    GOTO    QEN
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

; BEI 1 ZEIT ZHLEN, SIEHE GLEICH UNTERHALB
;----------- SEKUNDEN, MINUTEN UND STUNDEN ZHLUNG DER NORMALEN QUARZ-ZEIT ---

ZAEL
        MOVF    SEC, W
        ANDLW   0X0F
        ADDLW   0X01
        SUBLW   0X0A
        BTFSS   STATUS, Z
        GOTO    PPP0

        MOVF    SEC, W
        ANDLW   0XF0
        ADDLW   0X10
        GOTO    PPP1

PPP0    MOVF    SEC, W
        ADDLW   0X01

PPP1    MOVWF   SEC
        SUBLW   0X60
        BTFSS   STATUS, Z
        GOTO    MMA

        CLRF    SEC         ;
        MOVF    MIN, W
        ANDLW   0X0F
        ADDLW   0X01
        SUBLW   0X0A
        BTFSS   STATUS, Z
        GOTO    PPP2

        MOVF    MIN, W
        ANDLW   0XF0
        ADDLW   0X10
        GOTO    PPP3

PPP2    MOVF    MIN, W
        ADDLW   0X01

PPP3    MOVWF   MIN
        SUBLW   0X60
        BTFSS   STATUS, Z
        GOTO    MMA

        CLRF    MIN
        MOVF    H, W
        ANDLW   0X0F
        ADDLW   0X01
        SUBLW   0X0A
        BTFSS   STATUS, Z
        GOTO    PPP4

        MOVF    H, W
        ANDLW   0XF0
        ADDLW   0X10
        GOTO    PPP5

PPP4    MOVF    H, W
        ADDLW   0X01

PPP5    MOVWF   H
        SUBLW   0X24
        BTFSS   STATUS, Z
        GOTO    MMA
        CLRF    H

MMA     NOP


;==========================================================
;SEC-DARSTELLEN
            MOVF    SEC, W                  
            MOVWF   HELP2

            MOVLW   H'87'                  
            CALL    BEFEHL
            
            MOVF    HELP2, W
            ANDLW   H'0F'
            ADDLW   H'30'
            CALL    DATEN

            MOVLW   H'86'                  
            CALL    BEFEHL

            SWAPF   HELP2, W

            ANDLW   H'0F'
            ADDLW   H'30'
            CALL    DATEN

;MIN
            MOVF    MIN, W                  
            MOVWF   HELP2

            MOVLW   H'84'                  
            CALL    BEFEHL
            
            MOVF    HELP2, W
            ANDLW   H'0F'
            ADDLW   H'30'
            CALL    DATEN

            MOVLW   H'83'                  
            CALL    BEFEHL

            SWAPF   HELP2, W

            ANDLW   H'0F'
            ADDLW   H'30'
            CALL    DATEN

;H
            MOVF    H, W                  
            MOVWF   HELP2

            MOVLW   H'81'                  
            CALL    BEFEHL
            
            MOVF    HELP2, W
            ANDLW   H'0F'
            ADDLW   H'30'
            CALL    DATEN

            MOVLW   H'80'                  
            CALL    BEFEHL

            SWAPF   HELP2, W
            ANDLW   H'0F'
            ADDLW   H'30'

            SUBLW   H'30'
            BTFSC   STATUS, Z
            GOTO    CCBN

            SWAPF   HELP2, W
            ANDLW   H'0F'
            ADDLW   H'30'
            GOTO    CCCBN

CCBN        MOVLW   H'20'
CCCBN       CALL    DATEN



KMML        MOVLW   D'9'
            MOVWF   HELP0

;DOPPELPUNKT WIRD ANGEZEIGT
            MOVLW   H'82'                  
            CALL    BEFEHL
            MOVLW   H'3A'
            CALL    DATEN

            GOTO    EEE

NO_SEC      BTFSS   DCF_DA, BIT0    ;BEI DCF_DA=1 BLINKT ES
            GOTO    EEE

;DOPPELPUNKT WIRD AUSGESCHALTET
            MOVLW   H'82'                  
            CALL    BEFEHL
            MOVLW   H'20'
            CALL    DATEN


EEE         BTFSS   MERK, BIT7      ;KURZZEITIG BEI 00SEC BLINKEN,
            GOTO    QEN             ;WENN DIE DCF-ZEIT BERNOMMEN
            MOVLW   0X00            ;NUR EINE HALBE SEC BLINKEN
            SUBWF   SEC, W
            BTFSS   STATUS, Z
            GOTO    QEE

;FEHLER KOMMA
            MOVLW   H'85'                  
            CALL    BEFEHL
            MOVLW   H'2C'
            CALL    DATEN
            GOTO    QEN

QEE         BCF MERK, BIT7

;FEHLER PUNKT
            MOVLW   H'85'                  
            CALL    BEFEHL
            MOVLW   H'2E'
            CALL    DATEN


QEN         POP
            RETFIE

;*****************************************************************************
;*                              HAUPTPROGRAMM                                *
;*                              22.09.02                                     *
;*****************************************************************************
MAIN        BCF STATUS, RP0

;----------- INIT ALLE PORT'S ----------------------------------------------------

            CLRF    PORTA                           
            CLRF    PORTB
            MOVLW   0X07                    ;COMPARATORS ALLE AUS VOM PORT A
            MOVWF   CMCON
            BSF     STATUS, RP0             ;BANK1 
            MOVLW   B'11110000'             ;INIT INPUT/OUTPUT AM PORTA --> ALLES EINGAENGE AUSSER  RA0 RA1 RA2 RA3 ALS AUSGAENGE
            MOVWF   TRISA
            MOVLW   B'00001111'             ;INIT I/O PORTB ALLES AUSGAENGE FUER DATENBUS NUR RB0-RB3 EINGANG DA 4-BIT-DATENBUS...
            MOVWF   TRISB
            BCF     STATUS, RP0             ;BANK0

;----------- INIT 15 SEC PAUSE DAMIT DCF-77-EMPFNGER GUT EINSCHWINGT -------------
;----------- ES WIRD TIMER1 GENOMMEN ---------------------------------------------
;----------- DIE ZEIT IST 500MS BIS DAS OVERFOW-BIT IN PIR1 (TMR1F) BIT0 ZU 1 WIRD
;DA JETZT KEIN 4MHZ QUARZ SONDERN 16MHZ QUARZ ALLES *4 
        
            CLRF    INTCON              ;TIMER1 KEIN INTERRUPT
            BSF     STATUS, RP0         ;BANK1
            CLRF    PIE1                ;INTERRUPT-ENABLE-BIT IST DISABLE (MASKE)
            BCF     STATUS, RP0         ;BANK0
            BCF     PIR1, TMR1IF        ;OVERFLOW 0 MACHEN
            MOVLW   0XDB                ;500MS/32=15.625MS/0.25MYS=62500TAKTE
            MOVWF   TMR1L               ;0X10000-62500(0XF424)=0X0BDC  +2(JUSTAGE 32T*2=64T)==0X0BDE
            MOVLW   0X0B
            MOVWF   TMR1H
            MOVLW   0X31                ;PRESCALE1:8 / SYSTEMCLOCK T/4 ==>1/32
            MOVWF   T1CON               ;START TIMER1

            CLRF    PORTA
            CLRF    PORTB


            BCF     DECOD, BIT0     ;ES WURDE NOCH NICHT GESTELLT !!!
            CLRF    STELL           ;RESET FR STELLEN MITTELS TASTER


;ZEITSCHLEIFE VON 50MSEC, MUSS SEIN WEGEN ANSCHALTEN, DANN ERST DIE ERSTEN BEFEHLE
;DA JETZT KEIN 4MHZ QUARZ SONDERN 16MHZ QUARZ ALLES *4 MIT HELP0=4
            MOVLW   D'4'
            MOVWF   HELP0

S3          MOVLW   D'200'                  ;UNGEFAEHR 250SEC * 200 = 50MSEC
            MOVWF   HELP2

S0          MOVLW   D'250'                  ;UNGEFAEHR 250 SEC ZEITSCHLEIFE
            MOVWF   HELP1                   
S1          NOP                             ;T=4
            DECFSZ  HELP1, F                   ;T=4
            GOTO    S1                      ;T=4 ODER 8 ?
            DECFSZ  HELP2, F
            GOTO    S0          
            DECFSZ  HELP0, F
            GOTO    S3
;ENDE ZEITSCHLEIFE

;INITIALISIERUNG DOT-MATRIX-LCD
            MOVLW   H'28'                   ;FUNCTION SET  4-BIT-LAENGE, 2/4ZEILIG, 5X7FONT
            CALL    BEFEHL

            MOVLW   H'0C'                   ;DISPLAY ON/OFF   DISPLAY ON, CURSOR OFF, BLINK OFF
            CALL    BEFEHL

            MOVLW   H'01'                   ;CLEAR DISPLAY
            CALL    BEFEHL

;ZEITSCHLEIFE VON 2,5MSEC, MUSS SEIN WEGEN ANSCHALTEN, DANN ERST DIE ERSTEN BEFEHLE
;DA JETZT KEIN 4MHZ QUARZ SONDERN 16MHZ QUARZ ALLES *4 
            MOVLW   D'80'                   ;UNGEFAEHR 250SEC * 10 = 2,5MSEC  JETZT ABER 80
            MOVWF   HELP2

DD2         MOVLW   D'250'                  ;UNGEFAEHR 250 SEC ZEITSCHLEIFE
            MOVWF   HELP1
DD21        NOP
            DECFSZ  HELP1, F
            GOTO    DD21
            DECFSZ  HELP2, F
            GOTO    DD2          
;ENDE ZEITSCHLEIFE

;----------- LCD-DOT-MATRIX-AUSGEBEN ------------------------

            MOVLW   H'80'                   ;ADRESSE 0 
            CALL    BEFEHL
            MOVLW   H'47'
            CALL    DATEN

            MOVLW   H'81'                   ;ADRESSE 1
            CALL    BEFEHL
            MOVLW   H'65'
            CALL    DATEN

            MOVLW   H'82'                   ;ADRESSE 2
            CALL    BEFEHL
            MOVLW   H'68'
            CALL    DATEN

            MOVLW   H'83'                   ;ADRESSE 3
            CALL    BEFEHL
            MOVLW   H'74'
            CALL    DATEN

            MOVLW   H'84'                   ;ADRESSE 4
            CALL    BEFEHL
            MOVLW   H'20'
            CALL    DATEN

            MOVLW   H'85'                   ;ADRESSE 5
            CALL    BEFEHL
            MOVLW   H'67'
            CALL    DATEN

            MOVLW   H'86'                   ;ADRESSE 6
            CALL    BEFEHL
            MOVLW   H'6C'
            CALL    DATEN

            MOVLW   H'87'                   ;ADRESSE 7
            CALL    BEFEHL
            MOVLW   H'65'
            CALL    DATEN

            MOVLW   H'88'                   ;ADRESSE 8
            CALL    BEFEHL
            MOVLW   H'69'
            CALL    DATEN

            MOVLW   H'89'                   ;ADRESSE 9
            CALL    BEFEHL
            MOVLW   H'63'
            CALL    DATEN

            MOVLW   H'8A'                   ;ADRESSE A
            CALL    BEFEHL
            MOVLW   H'68'
            CALL    DATEN

            MOVLW   H'8B'                   ;ADRESSE B
            CALL    BEFEHL
            MOVLW   H'20'
            CALL    DATEN

            MOVLW   H'8C'                   ;ADRESSE C
            CALL    BEFEHL
            MOVLW   H'6C'
            CALL    DATEN

            MOVLW   H'8D'                   ;ADRESSE D
            CALL    BEFEHL
            MOVLW   H'6F'
            CALL    DATEN

            MOVLW   H'8E'                   ;ADRESSE E
            CALL    BEFEHL
            MOVLW   H'73'
            CALL    DATEN

;            MOVLW   H'8F'                   ;ADRESSE F
;            CALL    BEFEHL
;            MOVLW   H'73'
;            CALL    DATEN

;--------------------------------------------------------------
            MOVLW   H'C0'                   ;ADRESSE 0 
            CALL    BEFEHL
            MOVLW   H'2D'
            CALL    DATEN

            MOVLW   H'C1'                   ;ADRESSE 1
            CALL    BEFEHL
            MOVLW   H'2D'
            CALL    DATEN

            MOVLW   H'C2'                   ;ADRESSE 2
            CALL    BEFEHL
            MOVLW   H'2D'
            CALL    DATEN

            MOVLW   H'C3'                   ;ADRESSE 3
            CALL    BEFEHL
            MOVLW   H'2D'
            CALL    DATEN

            MOVLW   H'C4'                   ;ADRESSE 4
            CALL    BEFEHL
            MOVLW   H'2D'
            CALL    DATEN

            MOVLW   H'C5'                   ;ADRESSE 5
            CALL    BEFEHL
            MOVLW   H'2D'
            CALL    DATEN

            MOVLW   H'C6'                   ;ADRESSE 6
            CALL    BEFEHL
            MOVLW   H'2D'
            CALL    DATEN

            MOVLW   H'C7'                   ;ADRESSE 7
            CALL    BEFEHL
            MOVLW   H'2D'
            CALL    DATEN

            MOVLW   H'C8'                   ;ADRESSE 8
            CALL    BEFEHL
            MOVLW   H'2D'
            CALL    DATEN

            MOVLW   H'C9'                   ;ADRESSE 9
            CALL    BEFEHL
            MOVLW   H'2D'
            CALL    DATEN

            MOVLW   H'CA'                   ;ADRESSE A
            CALL    BEFEHL
            MOVLW   H'2D'
            CALL    DATEN

            MOVLW   H'CB'                   ;ADRESSE B
            CALL    BEFEHL
            MOVLW   H'2D'
            CALL    DATEN

            MOVLW   H'CC'                   ;ADRESSE C
            CALL    BEFEHL
            MOVLW   H'2D'
            CALL    DATEN

            MOVLW   H'CD'                   ;ADRESSE D
            CALL    BEFEHL
            MOVLW   H'2D'
            CALL    DATEN

            MOVLW   H'CE'                   ;ADRESSE E
            CALL    BEFEHL
            MOVLW   H'2D'
            CALL    DATEN

;            MOVLW   H'CF'                   ;ADRESSE F
;            CALL    BEFEHL
;            MOVLW   H'2D'
;            CALL    DATEN


;----------- 15 SEC PAUSENZEIT ABFRAGEN ------------------------------------------
;DA JETZT KEIN 4MHZ QUARZ SONDERN 16MHZ QUARZ ALLES *4 
    
        MOVLW   D'120'              ;500MS*30=15SEC ALSO JETZT *4= 30*4=120
        MOVWF   HELP0
                                    ;JUSTAGE
PAUSE0  BTFSS   PIR1, TMR1IF        ;SPRUNG BEI OVERFLOW = 1;8T FLLBYTE UM AUF 64T ZU KOMMEN
        GOTO    PAUSE0
    
        BCF     T1CON, TMR1ON       ;STOP TIMER1        ;4T
        DECFSZ  HELP0, F            ;SPRUNG BEI 0       ;4T
        GOTO    PAUSE1              ;8T
        GOTO    E_PAUSE             ;2*4+3*8=32

PAUSE1  NOP                         ;4T
        NOP                         ;4T
        NOP                         ;4T
        BCF     PIR1, TMR1IF        ;OVERFLOW 0 MACHEN  ;4T
        MOVLW   0XDE                ;4T
        MOVWF   TMR1L               ;4T
        MOVLW   0X0B                ;4T
        MOVWF   TMR1H               ;4T
        MOVLW   0X31                ;4T
        MOVWF   T1CON               ;START TIMER1       ;4T GESAMT=64T
        GOTO    PAUSE0

;----------- INIT 0.5 SEC --------------------------------------------------------
;----------- ES WIRD TIMER1 GENOMMEN MIT INTERRUPT -------------------------------
;----------- ZEITBASIS DER NORMALEN QUARZ-UHR ------------------------------------

E_PAUSE BCF     PIR1, TMR1IF        ;4T OVERFLOW 0 MACHEN
        BSF     INTCON, GIE         ;4T GLOBALER INTERRUPT ENABLE + PERIPHERAL INTERRUPT
        BSF     INTCON, PEIE        ;4T
        BSF     STATUS, RP0         ;4T BANK1
        BSF     PIE1, TMR1IE        ;4T TIMER1 OVERFLOW-INTERRUPT ENABLE
        BCF     STATUS, RP0         ;4T BANK0
        MOVLW   0XD0                ;4T 500MS/32=15.625MS/0.25MYS=62500TAKTE
        MOVWF   TMR1L               ;4T 65536(0X10000)-62500(0XF424)=3036(0X0BDC)
                                    ;      +2(JUSTAGE 32T*2=64T)==0X0BDE
        MOVLW   0X0B                ;4T
        MOVWF   TMR1H               ;4T

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;1. JUSTAGE
;2,5SEC IN 15H ZU VIEL
;15H*60=900MIN*60=54000SEC*2=108000ZYKLEN
;2,5SEC/108000ZYK.=23.148MYKROSEC
;23.148MYKROSEC/0.25=92TAKTE ALSO T
;92/32T=2.8 GENOMMEN 3
;ALSO 0X0BD8+3=0X0BDB KEINE NOP'S

;2. JUSTAGE
;0,8 SEC IN 48H ZU VIEL
;48H*60=2880MIN*60=172800SEC*2=345600ZYKLEN
;0,8 SEC/ 345600ZYK.=2,314MYKROSEC
;2.314MYKROSEC/0.25=9.256TAKTE ALSO T
;9.256/4T=2.3 GENOMMEN 2 * NOP
;ALSO 2*NOP (8T) HINZUGEFGT

;3. JUSTAGE
;1 SEC IN 24H ZU WENIG
;24H*60=1440MIN*60=86400SEC*2=172800ZYKLEN
;1 SEC/ 172800ZYK.=5,787MYKROSEC
;5,787MYKROSEC/0.25=23,14TAKTE ALSO T
;23,14/4T=5,78 GENOMMEN 5 * NOP
;ALSO 5*NOP (20T) HINZUGEFGT

    NOP
    NOP
    
    NOP
    NOP
    NOP
    NOP
    NOP


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;





    MOVLW   0X31        ;4T PRESCALE1:8 / SYSTEMCLOCK T/4 ==>1/32
    MOVWF   T1CON       ;4T START TIMER1
                        ;GESAMT: 32T+13*4T=84T //20*0.25MYS=5MYS ZU LANG
    MOVLW   D'9'
    MOVWF   HELP0



;----------- GRUNDEINSTELLUNG FR NORMAL-QUARZ-UHR -------------------------------
;----------- UND ANZEIGE ---------------------------------------------------------


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;ANZEIGE RAUS GENOMMEN

            CLRF   H
 ;   MOVWF   PORTD


            CLRF   MIN
;    MOVWF   PORTB

            CLRF   SEC
;========================================================

            MOVLW   H'01'                   ;CLEAR DISPLAY
            CALL    BEFEHL

;ZEITSCHLEIFE VON 2,5MSEC, MUSS SEIN WEGEN ANSCHALTEN, DANN ERST DIE ERSTEN BEFEHLE
;DA JETZT KEIN 4MHZ QUARZ SONDERN 16MHZ QUARZ ALLES *4 
            MOVLW   D'80'                   ;UNGEFAEHR 250SEC * 10 = 2,5MSEC  JETZT ABER 80
            MOVWF   HELP2

DDM2        MOVLW   D'250'                  ;UNGEFAEHR 250 SEC ZEITSCHLEIFE
            MOVWF   HELP1
DDM21       NOP
            DECFSZ  HELP1, F
            GOTO    DDM21
            DECFSZ  HELP2, F
            GOTO    DDM2          
;ENDE ZEITSCHLEIFE


            MOVLW   H'80'                   ;ADRESSE 0 
            CALL    BEFEHL
            MOVLW   H'20'
            CALL    DATEN

            MOVLW   H'81'                   ;ADRESSE 1
            CALL    BEFEHL
            MOVLW   H'30'
            CALL    DATEN

            MOVLW   H'82'                   ;ADRESSE 2
            CALL    BEFEHL
            MOVLW   H'3A'
            CALL    DATEN

            MOVLW   H'83'                   ;ADRESSE 3
            CALL    BEFEHL
            MOVLW   H'30'
            CALL    DATEN

            MOVLW   H'84'                   ;ADRESSE 4
            CALL    BEFEHL
            MOVLW   H'30'
            CALL    DATEN

            MOVLW   H'85'                   ;ADRESSE 5
            CALL    BEFEHL
            MOVLW   H'2E'
            CALL    DATEN

            MOVLW   H'86'                   ;ADRESSE 6
            CALL    BEFEHL
            MOVLW   H'30'
            CALL    DATEN

            MOVLW   H'87'                   ;ADRESSE 7
            CALL    BEFEHL
            MOVLW   H'30'
            CALL    DATEN

;========================================================


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

            CLRF    DCF_DA          ;DCF IST NICHT DA, ES BLINKT NICHT
;    BCF PORTB, FEHLER   ;FEHLERPUNKT NICHT DARSTELLEN

;            MOVLW   H'85'                  
;            CALL    BEFEHL
;            MOVLW   H'2E'
;            CALL    DATEN


            CLRF    MERK
            BSF     MERK, BIT6      ;BEI NICHT BEREINSTIMMUNG MIN/H 1.-TES OK ZULASSEN
                                    ;ABER NUR BEIM START

;----------- DCF-SIGNAL DECODIEREN -----------------------------------------------
;----------- DCF-SEC-IMPULS-ANFANG FINDEN ----------------------------------------

SYN         CLRF    ZUST
            CLRF    Z_LL
            CLRF    Z_LH

            BCF     DCF_DA, BIT0    ;DCF IST NICHT DA, ES BLINKT NICHT
;    BCF PORTB, FEHLER   ;FEHLERPUNKT NICHT DARSTELLEN

;            MOVLW   H'85'                  
;            CALL    BEFEHL
;            MOVLW   H'66'
;            CALL    DATEN


            MOVLW   D'4'
            MOVWF   X4
 
SEC0        BCF     INTCON, GIE ;INTERRUPT SPERREN, DA BANK1 VORKOMMT
            BTFSC   INTCON, GIE
            GOTO    SEC0
            MS1
            BSF     INTCON, GIE     ;INTERRUPT WIEDER ZULASSEN

SCHA        BTFSS   INTCON, T0IF    ;OVERFLOW 1MS
            GOTO    SCHA

            DECFSZ  X4, F
            GOTO    SEC0

            BTFSC   PORTA, BIT4
            GOTO    SEC1            ;HIGH-IMPULS-BEGINN ERKANNT
            INCF    Z_LL, F         ;LOW-IMPULS ZHLEN
            BTFSS   STATUS, Z       ;BERTRAG VON FF --> 00
            GOTO    SEC0
            BSF     Z_LH, BIT0
            GOTO    SEC0

SEC1        BTFSC   Z_LH, BIT0      ;GRER ALS FF LOW-SEC-LCKE
            GOTO    LUECKE

SEC2        MOVLW   0X02            ;GRER ALS 02 LOW-SEC-LCKE
            SUBWF   Z_LL, W
            BTFSS   STATUS, C
            GOTO    SYN

;------------ DCF-MINUTEN LCKE FINDEN ------------------------------------------

LUECKE      CLRF    Z_LL            ;MTE MIT HIGH IMPULS BEGINNEN
            CLRF    Z_LH            ;ES WERDEN NUR DIE LOW-ZEITEM GEMESSEN

L1          BTFSC   PORTA, BIT4
            GOTO    L2

            MOVLW   D'4'
            MOVWF   X4
 
LOOP1       BCF     INTCON, GIE     ;INTERRUPT SPERREN, DA BANK1 VORKOMMT
            BTFSC   INTCON, GIE
            GOTO    LOOP1
            MS1
            BSF     INTCON, GIE     ;INTERRUPT WIEDER ZULASSEN

SCH         BTFSS   INTCON, T0IF    ;OVERFLOW 1MS
            GOTO    SCH

            DECFSZ  X4, F
            GOTO    LOOP1

            INCFSZ  Z_LL, F
            GOTO    L1
            INCFSZ  Z_LH, F
            GOTO    L1
            GOTO    SYN             ;DCF IST NICHT DA, AUSWERTUNG NACH 0XFFFF 65.535MS
                                    ;ES BLINKT NICHT

L2          MOVLW   0X05            ;GRER ALS 0X0500 ALSO 1280MS
            SUBWF   Z_LH, W
            BTFSS   STATUS, C
            GOTO    LUECKE
 ;   BCF PORTB, FEHLER       ;FEHLERPUNKT NICHT DARSTELLEN

;            MOVLW   H'85'                  
;            CALL    BEFEHL
;            MOVLW   H'2E'
;            CALL    DATEN

            BSF DCF_DA, BIT0        ;ES BLINKT

;------------ DCF-IMPULSE ERFASSEN ---------------------------------------------

IMPULS  CLRF    Z_IMP       ;BEGINNT MIT HIGH-IMPULS
        CLRF    I_MIN
        CLRF    I_H
        CLRF    OK
        BSF     OK, BIT2    ;RAHMENFEHLER < > IST IN ORDNUNG, WIRD BEI FEHLER ZURCKGESETZT
        CLRF    PAR         ;UNGERADE PARITT BEGINN IST JETZT 0X00
        CLRF    WOC         ;WOCHENTAG
        CLRF    KALT        ;KALENDERTAG
        CLRF    MONA        ;MONAT
        CLRF    JAR         ;JAHR

I1      CLRF    Z_H
        CLRF    Z_LL
        CLRF    Z_LH

I2      BTFSS   PORTA, BIT4 ;HIGH-IMPULS MESSEN
        GOTO    I10         ;SPRUNG BEI LOW ZUR AUSWERTUNG

        MOVLW   D'4'
        MOVWF   X4
 
LOOP2   BCF INTCON, GIE     ;INTERRUPT SPERREN, DA BANK1 VORKOMMT
        BTFSC   INTCON, GIE
        GOTO    LOOP2
        MS1
        BSF INTCON, GIE     ;INTERRUPT WIEDER ZULASSEN

SCH1    BTFSS   INTCON, T0IF    ;OVERFLOW 1MS
        GOTO    SCH1

        DECFSZ  X4, F
        GOTO    LOOP2

        INCFSZ  Z_H, F          ;ACHTUNG HIER KNNTE FEHLER AUFTRETEN --> JETZT NICHT MEHR
        GOTO    I2
        GOTO    SYN

I10     AUSW                    ;AUSWERTUNG

;   MOVWF   PORTD

        INCF    Z_IMP, F

I111    BTFSC   PORTA, BIT4 ;LOW-IMPULS ZEITBERSCHREITUNG
        GOTO    I111A

        MOVLW   D'4'
        MOVWF   X4
 
LOOP3   BCF     INTCON, GIE     ;INTERRUPT SPERREN, DA BANK1 VORKOMMT
        BTFSC   INTCON, GIE
        GOTO    LOOP3
        MS1
        BSF     INTCON, GIE     ;INTERRUPT WIEDER ZULASSEN

SCH2    BTFSS   INTCON, T0IF    ;OVERFLOW 1MS
        GOTO    SCH2

        DECFSZ  X4, F
        GOTO    LOOP3

        INCFSZ  Z_LL, F
        GOTO    I111
        INCFSZ  Z_LH, F
        GOTO    I111
        GOTO    SYN             ;ZEITBERSCHREITUNG ES FEHLT DCF

I111A   MOVLW   0X05            ;GRER ALS 0X0500 ALSO 1280MS
        SUBWF   Z_LH, W
        BTFSS   STATUS, C
        GOTO    I1              ;ES IST EINE SEC VORBEI MIT HIGH + DANN LOW

;--------------- MINUTENLCKE AN DER RICHTIGEN STELLE ----------------------------

        MOVLW   D'59'       ;MIN-LCKEN ERKENNUNG OK???
        SUBWF   Z_IMP, W
        BTFSS   STATUS, Z
        GOTO    SCHB        ;FEHLER BEI IMPULSANZAHL

;--------------- OB KEIN FEHLER (PARITTBIT 0+1/RAHMEN <> BIT2) ------------------

        MOVLW   0X07
        SUBWF   OK, W
        BTFSS   STATUS, Z
        GOTO    SCHB        ;FEHLER BEI PARITT + RAHMEN

;--------------- OB ZEIT RICHTIG GEMESSEN, DANN DARSTELLEN ----------------------
    
        BTFSS   MERK, BIT6  ;BEI START SOFORT ZULASSEN
        GOTO    LLKM
        BCF MERK, BIT6
        GOTO    LOP11

LLKM    MOVLW   D'100'      ;BEI QUARZZEIT NICHT == GEMESSENER ZEIT
        SUBWF   ZUST, W
        BTFSS   STATUS, Z
        GOTO    NO          ;NICHT ZEIT DARSTELLEN, ZEIT NICHT RICHTIG GEMESSEN
                            ;KEINE BEREINSTIMMUNG

LOP11   CLRF    ZUST    ;JETZT GEHT NORMALE ZEITBEREINSTIMMUNG
        BSF MERK, BIT7      ;VON 00SEC ZU 01SEC FEHLERBLINKEN

;----------- QUARZ-ZEIT RICHTIG STARTEN ------------------------------------------

LOP1    BCF     INTCON, GIE ;INTERRUPT SPERREN, DA BANK1 VORKOMMT
        BTFSC   INTCON, GIE
        GOTO    LOP1
    
        BCF     T1CON, TMR1ON   ;STOP TIMER1        ;4T + 8TINTERRUPT? JUSTAGE
        BCF     PIR1, TMR1IF    ;OVERFLOW 0 MACHEN  ;4T
        BSF     INTCON, PEIE    ;ZUR SICHERHEIT PERIPH. INTERRUPT ZULASSEN
        MOVLW   0XDB        ;4T
        MOVWF   TMR1L       ;4T
        MOVLW   0X0B        ;4T
        MOVWF   TMR1H       ;4T
        MOVLW   0X31        ;+STEUERBITS FR DIESEN TIMER   ;4T
        MOVWF   T1CON       ;START TIMER1       ;4T GESAMT=14*4T + 1*8T=64T
    
        BSF     INTCON, GIE ;INTERRUPT WIEDER ZULASSEN

;----------- ZEIT EXAKT EINSTELLEN -----------------------------------------------
    
        CLRF    SEC         ;SEC NULLEN
        MOVF    I_MIN, W
        MOVWF   MIN
        MOVF    I_H, W
        MOVWF   H

        BSF     DECOD, BIT0     ;ES WURDE GESTELLT !!!

;----------- MIN UND H ANZEIGE AUF LCD-PORT'S --------------------------------

;    MOVF    H, W        ;HIER ERFOLGT DIE VORNULLEN AUSBLENDUNG MIT 0XF?
;    ANDLW   0XF0        ;BEI 0X00 Z-FLAG GESETZT
;    BTFSS   STATUS, Z   ;SPRUNG BEI Z-FLAG GESETZT, ALSO BEI 0X0?, ALSO AUSBLENDEN
;    GOTO    BMM0

;    MOVF    H, W
;    ADDLW   0XF0
;    MOVWF   PORTD
;    GOTO    BMM1

;BMM0    MOVF    H, W
;    MOVWF   PORTD

;BMM1    MOVF    MIN, W
;    MOVWF   PORTB

;==========================================================
;SEC-DARSTELLEN
            MOVF    SEC, W                  
            MOVWF   HELP2

            MOVLW   H'87'                  
            CALL    BEFEHL
            
            MOVF    HELP2, W
            ANDLW   H'0F'
            ADDLW   H'30'
            CALL    DATEN

            MOVLW   H'86'                  
            CALL    BEFEHL

            SWAPF   HELP2, W

            ANDLW   H'0F'
            ADDLW   H'30'
            CALL    DATEN

;MIN
            MOVF    MIN, W                  
            MOVWF   HELP2

            MOVLW   H'84'                  
            CALL    BEFEHL
            
            MOVF    HELP2, W
            ANDLW   H'0F'
            ADDLW   H'30'
            CALL    DATEN

            MOVLW   H'83'                  
            CALL    BEFEHL

            SWAPF   HELP2, W

            ANDLW   H'0F'
            ADDLW   H'30'
            CALL    DATEN

;H
            MOVF    H, W                  
            MOVWF   HELP2

            MOVLW   H'81'                  
            CALL    BEFEHL
            
            MOVF    HELP2, W
            ANDLW   H'0F'
            ADDLW   H'30'
            CALL    DATEN

            MOVLW   H'80'                  
            CALL    BEFEHL

            SWAPF   HELP2, W
            ANDLW   H'0F'
            ADDLW   H'30'

            SUBLW   H'30'
            BTFSC   STATUS, Z
            GOTO    CCBN1

            SWAPF   HELP2, W
            ANDLW   H'0F'
            ADDLW   H'30'
            GOTO    CCCBN1

CCBN1       MOVLW   H'20'
CCCBN1      CALL    DATEN


;KALENDERTAG DARSTELLUNG
            MOVF    KALT, W                  
            MOVWF   HELP2

            MOVLW   H'C5'                  
            CALL    BEFEHL
            
            MOVF    HELP2, W
            ANDLW   H'0F'
            ADDLW   H'30'
            CALL    DATEN

            MOVLW   H'C4'                  
            CALL    BEFEHL

            SWAPF   HELP2, W
            ANDLW   H'0F'
            ADDLW   H'30'

            SUBLW   H'30'
            BTFSC   STATUS, Z
            GOTO    ABN1

            SWAPF   HELP2, W
            ANDLW   H'0F'
            ADDLW   H'30'
            GOTO    AABN1

ABN1      MOVLW   H'20'
AABN1     CALL    DATEN

;MONAT
            MOVF    MONA, W                  
            MOVWF   HELP2

            MOVLW   H'C8'                  
            CALL    BEFEHL
            
            MOVF    HELP2, W
            ANDLW   H'0F'
            ADDLW   H'30'
            CALL    DATEN

            MOVLW   H'C7'                  
            CALL    BEFEHL

            SWAPF   HELP2, W

            ANDLW   H'0F'
            ADDLW   H'30'
            CALL    DATEN

;JAHR
            MOVF    JAR, W                  
            MOVWF   HELP2

            MOVLW   H'CD'                  
            CALL    BEFEHL
            
            MOVF    HELP2, W
            ANDLW   H'0F'
            ADDLW   H'30'
            CALL    DATEN

            MOVLW   H'CC'                  
            CALL    BEFEHL

            SWAPF   HELP2, W

            ANDLW   H'0F'
            ADDLW   H'30'
            CALL    DATEN


 
;MESZ + MEZ DARSTELLEN
            BTFSC   SZ, BIT0
            GOTO    SZZZ
            
            MOVLW   H'89'                   ;ADRESSE 9
            CALL    BEFEHL
            MOVLW   H'4D'
            CALL    DATEN

            MOVLW   H'8A'                   ;ADRESSE A
            CALL    BEFEHL
            MOVLW   H'45'
            CALL    DATEN

            MOVLW   H'8B'                   ;ADRESSE B
            CALL    BEFEHL
            MOVLW   H'5A'
            CALL    DATEN

            MOVLW   H'8C'                   ;ADRESSE C
            CALL    BEFEHL
            MOVLW   H'20'
            CALL    DATEN
            GOTO    KMLLL1

SZZZ        MOVLW   H'89'                   ;ADRESSE 9
            CALL    BEFEHL
            MOVLW   H'4D'
            CALL    DATEN

            MOVLW   H'8A'                   ;ADRESSE A
            CALL    BEFEHL
            MOVLW   H'45'
            CALL    DATEN

            MOVLW   H'8B'                   ;ADRESSE B
            CALL    BEFEHL
            MOVLW   H'53'
            CALL    DATEN

            MOVLW   H'8C'                   ;ADRESSE C
            CALL    BEFEHL
            MOVLW   H'5A'
            CALL    DATEN
    
;WOCHENTAG DARSTELLEN
KMLLL1      MOVLW   0X01                    ;MON
            SUBWF   WOC, W
            BTFSS   STATUS, Z
            GOTO    WKK1
           
            MOVLW   H'C0'                   ;ADRESSE 0
            CALL    BEFEHL
            MOVLW   H'4D'
            CALL    DATEN
            MOVLW   H'C1'                   ;ADRESSE 1
            CALL    BEFEHL
            MOVLW   H'6F'
            CALL    DATEN
            MOVLW   H'C2'                   ;ADRESSE 2
            CALL    BEFEHL
            MOVLW   H'6E'
            CALL    DATEN
            GOTO    KMML1

WKK1        MOVLW   0X02                    ;DIE
            SUBWF   WOC, W
            BTFSS   STATUS, Z
            GOTO    WKK2
           
            MOVLW   H'C0'                   ;ADRESSE 0
            CALL    BEFEHL
            MOVLW   H'44'
            CALL    DATEN
            MOVLW   H'C1'                   ;ADRESSE 1
            CALL    BEFEHL
            MOVLW   H'69'
            CALL    DATEN
            MOVLW   H'C2'                   ;ADRESSE 2
            CALL    BEFEHL
            MOVLW   H'65'
            CALL    DATEN
            GOTO    KMML1

WKK2        MOVLW   0X03                    ;MIT
            SUBWF   WOC, W
            BTFSS   STATUS, Z
            GOTO    WKK3
           
            MOVLW   H'C0'                   ;ADRESSE 0
            CALL    BEFEHL
            MOVLW   H'4D'
            CALL    DATEN
            MOVLW   H'C1'                   ;ADRESSE 1
            CALL    BEFEHL
            MOVLW   H'69'
            CALL    DATEN
            MOVLW   H'C2'                   ;ADRESSE 2
            CALL    BEFEHL
            MOVLW   H'74'
            CALL    DATEN
            GOTO    KMML1

WKK3        MOVLW   0X04                    ;DON
            SUBWF   WOC, W
            BTFSS   STATUS, Z
            GOTO    WKK4
           
            MOVLW   H'C0'                   ;ADRESSE 0
            CALL    BEFEHL
            MOVLW   H'44'
            CALL    DATEN
            MOVLW   H'C1'                   ;ADRESSE 1
            CALL    BEFEHL
            MOVLW   H'6F'
            CALL    DATEN
            MOVLW   H'C2'                   ;ADRESSE 2
            CALL    BEFEHL
            MOVLW   H'6E'
            CALL    DATEN
            GOTO    KMML1

WKK4        MOVLW   0X05                    ;FRE
            SUBWF   WOC, W
            BTFSS   STATUS, Z
            GOTO    WKK5
           
            MOVLW   H'C0'                   ;ADRESSE 0
            CALL    BEFEHL
            MOVLW   H'46'
            CALL    DATEN
            MOVLW   H'C1'                   ;ADRESSE 1
            CALL    BEFEHL
            MOVLW   H'72'
            CALL    DATEN
            MOVLW   H'C2'                   ;ADRESSE 2
            CALL    BEFEHL
            MOVLW   H'65'
            CALL    DATEN
            GOTO    KMML1

WKK5        MOVLW   0X06                    ;SAM
            SUBWF   WOC, W
            BTFSS   STATUS, Z
            GOTO    WKK6
           
            MOVLW   H'C0'                   ;ADRESSE 0
            CALL    BEFEHL
            MOVLW   H'53'
            CALL    DATEN
            MOVLW   H'C1'                   ;ADRESSE 1
            CALL    BEFEHL
            MOVLW   H'61'
            CALL    DATEN
            MOVLW   H'C2'                   ;ADRESSE 2
            CALL    BEFEHL
            MOVLW   H'6D'
            CALL    DATEN
            GOTO    KMML1

WKK6        MOVLW   0X07                    ;SON
            SUBWF   WOC, W
            BTFSS   STATUS, Z
            GOTO    KMML1
           
            MOVLW   H'C0'                   ;ADRESSE 0
            CALL    BEFEHL
            MOVLW   H'53'
            CALL    DATEN
            MOVLW   H'C1'                   ;ADRESSE 1
            CALL    BEFEHL
            MOVLW   H'6F'
            CALL    DATEN
            MOVLW   H'C2'                   ;ADRESSE 2
            CALL    BEFEHL
            MOVLW   H'6E'
            CALL    DATEN



KMML1       MOVLW   H'C6'                   ;ADRESSE 6
            CALL    BEFEHL
            MOVLW   H'2D'
            CALL    DATEN
            MOVLW   H'C9'                   ;ADRESSE 9
            CALL    BEFEHL
            MOVLW   H'2D'
            CALL    DATEN
            MOVLW   H'CA'                   ;ADRESSE A
            CALL    BEFEHL
            MOVLW   H'32'
            CALL    DATEN
            MOVLW   H'CB'                   ;ADRESSE B
            CALL    BEFEHL
            MOVLW   H'30'
            CALL    DATEN


      



            MOVLW   D'9'
            MOVWF   HELP0

;DOPPELPUNKT WIRD ANGEZEIGT
            MOVLW   H'82'                   
            CALL    BEFEHL
            MOVLW   H'3A'
            CALL    DATEN
        


;FEHLERPUNKT NICHT DARSTELLEN
NO          MOVLW   H'85'                  
            CALL    BEFEHL
            MOVLW   H'2E'
            CALL    DATEN


            BSF     DCF_DA, BIT0    ;ES BLINKT
            GOTO    IMPULS          ;ES IST 1MIN VORBEI HIER IST MIN-LCKE ERKANNT

SCHB        CLRF    ZUST

;FEHLERPUNKT NICHT DARSTELLEN
            MOVLW   H'85'                  
            CALL    BEFEHL
            MOVLW   H'2E'
            CALL    DATEN


            BSF     DCF_DA, BIT0    ;ES BLINKT
            GOTO    IMPULS


;*****************************************************************************
;*                              UNTERPRG. (H UND MIN +1)                     *
;*                              09.10.02                                     *
;*****************************************************************************
PLUS1   MOVF    MIN_V, W
        ANDLW   0X0F
        ADDLW   0X01
        SUBLW   0X0A
        BTFSS   STATUS, Z
        GOTO    JPP2
    
        MOVF    MIN_V, W
        ANDLW   0XF0
        ADDLW   0X10
        GOTO    JPP3

JPP2    MOVF    MIN_V, W
        ADDLW   0X01

JPP3    MOVWF   MIN_V
        SUBLW   0X60
        BTFSS   STATUS, Z
        GOTO    EEEND
    
        MOVWF   MIN_V
        MOVF    H_V, W
        ANDLW   0X0F
        ADDLW   0X01
        SUBLW   0X0A
        BTFSS   STATUS, Z
        GOTO    JPP4
    
        MOVF    H_V, W
        ANDLW   0XF0
        ADDLW   0X10
        GOTO    JPP5

JPP4    MOVF    H_V, W
        ADDLW   0X01

JPP5    MOVWF   H_V
        SUBLW   0X24
        BTFSS   STATUS, Z
        GOTO    EEEND
        MOVWF   H_V

EEEND   RETURN





;*****************************************************************************
;*                              DATEN AUSGEBEN AUF DOT-LCD-MODUL             *
;*                              04.05.10                                     *
;*****************************************************************************
DATEN       BSF     PORTA, RS               ;ALS DATEN

            MOVWF   BIT

            MOVF    PORTB, W
            ANDLW   0X0F
            MOVWF   MERKE

            MOVF    BIT, W
            ANDLW   0XF0
            ADDWF   MERKE, W
            MOVWF   PORTB


            BSF     PORTA, EN

;ZEITSCHLEIFE 4SEC
            MOVLW   D'4'                    ;UNGEFAEHR 4SEC ZEITSCHLEIFE
            MOVWF   HELP1
D1          NOP                             ;T=4
            DECFSZ  HELP1, F                ;T=4
            GOTO    D1                      ;T=8    GES.:16TAKTE * 0,0625SEC= 1SEC    *4 DURCHLAEUFE= 4SEC
;ENDE ZEITSCHLEIFE
 
            BCF     PORTA, EN

;---------------------------------

;LOW 4BIT AUSGEBEN
            RLF     BIT, F
            RLF     BIT, F
            RLF     BIT, F
            RLF     BIT, F

            MOVF    PORTB, W
            ANDLW   0X0F
            MOVWF   MERKE

            MOVF    BIT, W
            ANDLW   0XF0
            ADDWF   MERKE, W
            MOVWF   PORTB


            BSF     PORTA, EN

;ZEITSCHLEIFE 4SEC
            MOVLW   D'4'                    
            MOVWF   HELP1
DDD1        NOP                             
            DECFSZ  HELP1, F                
            GOTO    DDD1                    
;ENDE ZEITSCHLEIFE
 
            BCF     PORTA, EN

;ZEITSCHLEIFE 40SEC
            MOVLW   D'40'                   ;UNGEFAEHR 40SEC ZEITSCHLEIFE
            MOVWF   HELP1
DDDD1       NOP
            DECFSZ  HELP1, F                ;WIE OBEN  
            GOTO    DDDD1
;ENDE ZEITSCHLEIFE



            RETURN

;*****************************************************************************
;*                              BEFEHL AUSGEBEN AUF DOT-LCD-MODUL            *
;*                              04.05.10                                     *
;*****************************************************************************
BEFEHL      BCF     PORTA, RS                ;ALS BEFEHL

            MOVWF   BIT

            MOVF    PORTB, W
            ANDLW   0X0F
            MOVWF   MERKE

            MOVF    BIT, W
            ANDLW   0XF0
            ADDWF   MERKE, W
            MOVWF   PORTB

            BSF     PORTA, EN

;ZEITSCHLEIFE 4SEC
            MOVLW   D'4'                    ;UNGEFAEHR 8SEC ZEITSCHLEIFE
            MOVWF   HELP1
B1          NOP                             ;T=4
            DECFSZ  HELP1, F                ;T=4
            GOTO    B1                      ;T=8        GES.:16TAKTE * 0,0625SEC= 1SEC    *4 DURCHLAEUFE= 4SEC
;ENDE ZEITSCHLEIFE
 
            BCF     PORTA, EN

;---------------------------------

;LOW 4BIT AUSGEBEN
            RLF     BIT, F
            RLF     BIT, F
            RLF     BIT, F
            RLF     BIT, F

            MOVF    PORTB, W
            ANDLW   0X0F
            MOVWF   MERKE

            MOVF    BIT, W
            ANDLW   0XF0
            ADDWF   MERKE, W
            MOVWF   PORTB

            BSF     PORTA, EN

;ZEITSCHLEIFE 4SEC
            MOVLW   D'4'                    
            MOVWF   HELP1
BBB1        NOP                             
            DECFSZ  HELP1, F                
            GOTO    BBB1                    
;ENDE ZEITSCHLEIFE
 
            BCF     PORTA, EN

;ZEITSCHLEIFE 40SEC
            MOVLW   D'40'                   ;UNGEFAEHR 40SEC ZEITSCHLEIFE
            MOVWF   HELP1
BBBB1       NOP
            DECFSZ  HELP1, F                ;WIE OBEN  
            GOTO    BBBB1
;ENDE ZEITSCHLEIFE
 
            RETURN


        ORG 0X0700
;*****************************************************************************
;*                              GERADE MIN TABELLE                           *
;*****************************************************************************
GERADE
    MOVLW   H'07'       ;ADRESSE SPEICHERN NEUES PCLATH///
    MOVWF   PCLATH

    MOVF    ZAE, W     ; SPRUNGDISTANZ
    ADDWF   PCL,F       ; AUF STELLE DES ZU LESENDEN BYTES BRINGEN  

    
;----------------------------------------------------------------------------------------------
;----------------------------------------------------------------------------------------------
        
    RETLW H'00'  
    RETLW H'02'
    RETLW H'04'
    RETLW H'06'
    RETLW H'08'

    RETLW H'10'  
    RETLW H'12'
    RETLW H'14'
    RETLW H'16'
    RETLW H'18'

    RETLW H'20'  
    RETLW H'22'
    RETLW H'24'
    RETLW H'26'
    RETLW H'28'

    RETLW H'30'  
    RETLW H'32'
    RETLW H'34'
    RETLW H'36'
    RETLW H'38'

    RETLW H'40'  
    RETLW H'42'
    RETLW H'44'
    RETLW H'46'
    RETLW H'48'

    RETLW H'50'  
    RETLW H'52'
    RETLW H'54'
    RETLW H'56'
    RETLW H'58'

    RETLW 0XFF      ;ENDEKENNZEICHEN MUSS DRIN SEIN /// ICH BENUTZE ES IMMER IN EINER TABELLE







            END
